//+------------------------------------------------------------------+
//|                                                     10point3.mq4 |
//|                              Copyright  2005, Alejandro Galindo |
//|                                   Revised version from davidke20 |
//|                 Settings by Marcel Corzo - marcelcorzo@yahoo.com |
//|               Added Benkyalate system by Yast77                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      ""

extern int    Magic              = 772177;
extern double TakeProfit         = 150;
extern double Lots               = 0.01;
extern double InitialStop        = 1000;
extern double TrailingStop       = 100;
extern int    MaxTrades          = 3;
extern double Multiplier         = 2;
extern int    Pips               = 100;
extern int    OrderstoProtect    = 6;
extern bool   Money_management   = True;
extern int    AccountType        = 0;        //0: Standard account(NorthFinance,MiG,Alpari) 1: Normal account(FXLQ,FXDD) 2:InterbankFX's NANO Account
extern double risk               = 1;
extern bool   ReverseSignal      = false;

//extern int    Fast_EMA           = 12;
//extern int    Slow_EMA           = 26;
//extern int    Signal_SMA         = 9;
//extern int    Shift              = 1;
//extern int    TradingRange       = 0;
extern bool UseTimeFilter=false;
extern int StopTrade = 18;
extern int StartTrade = 19;

extern int COG_Period = 0;
extern int bars_back1 = 120;  //top dotted line value
extern int m_cog1 = 4;
extern int i_cog1 = 0;
extern double kstd1 = 2.4;
extern int sName1 = 720;


extern int bars_back2 = 120;  //top solid line value
extern int m_cog2 = 4;
extern int i_cog2 = 0;
extern double kstd2 = 3.4;
extern int sName2 = 720;


extern int bars_back3 = 120;  //bottom dotted line value
extern int m_cog3 = 4;
extern int i_cog3 = 0;
extern double kstd3 = 2.4;
extern int sName3 = 720;


extern int bars_back4 = 120;  //bottom solid line value
extern int m_cog4 = 4;
extern int i_cog4 = 0;
extern double kstd4 = 3.4;
extern int sName4 = 720;

extern int CAN_Period =0;
extern int       Length=3;
extern int       H_period=3;
extern int       L_period=3;
extern int       C_period=3;

extern int CCI_Period=0;
extern int CCI_lenght= 20;
extern int RSI_Period=0;
extern int RSI= 14;
   
extern int MACD_Period=0;   
   
   


  
datetime TimeStamp=0;
int  OpenOrders=0, cnt=0;
int  slippage=5;
double sl=0, tp=0;
double BuyPrice=0, SellPrice=0;
double lotsi=0, mylotsi=0;
int mode=0, myOrderType=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0;
double Profit=0;
int LastTicket=0, LastType=0;
double LastClosePrice=0, LastLots=0;
double PipValue=0;
string text="", text2="",text3="",text4="";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

   double MinLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2);
   double MaxLots = NormalizeDouble((MarketInfo(Symbol(), MODE_MAXLOT)),2);
   double LotSizeValue = NormalizeDouble((MarketInfo(Symbol(), MODE_LOTSIZE)),0);
   double PipValue=MarketInfo(Symbol(),16);

   if(Money_management)
   {
      switch(AccountType)
      {
         case 0: lotsi=NormalizeDouble(MathCeil((risk*AccountEquity())/10000)/10,1); break;
         case 1: lotsi=NormalizeDouble((risk*AccountEquity())/100000,2); break;
         case 2: lotsi=NormalizeDouble((risk*AccountEquity())/1000,2); break;
         default: lotsi=NormalizeDouble(MathCeil((risk*AccountEquity())/10000)/10,1); break;
      }
   }
   else
   {
      lotsi=Lots;
   }
   
   if(lotsi<MinLots){lotsi=MinLots;}
   if(lotsi>MaxLots){lotsi=MaxLots;}
   
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			return(0);
		 }
	  }
   }

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }

   if (OpenOrders<1) 
   {
     if (UseTimeFilter)
     {//check trading time
        if (Hour()>StopTrade && Hour()<StartTrade) 
        {Comment("No trading, danger time zone!");
        return(0);}//End of trading time check
     }

	     myOrderType=MACD();


     	  if (ReverseSignal)
	     {
	  	     if (myOrderType==1) { myOrderType=2; }
		    else { if (myOrderType==2) { myOrderType=1; } }
	     }
   }

   // if we have opened positions we take care of them
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop*Point+Pips*Point))  
				  {						
					 if (OrderStopLoss()>(Ask+Point*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,800,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop*Point+Pips*Point))  
				{
					if (OrderStopLoss()<(Bid-Point*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,800,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{
				//Profit=Profit+(Ord(cnt,VAL_CLOSEPRICE)-Ord(cnt,VAL_OPENPRICE))*PipValue*Ord(cnt,VAL_LOTS);				
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			}
			if (LastType==OP_SELL) 
			{
				//Profit=Profit+(Ord(cnt,VAL_OPENPRICE)-Ord(cnt,VAL_CLOSEPRICE))*PipValue*Ord(cnt,VAL_LOTS);
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
			}
			//Print(Symbol,":",Profit,",",LastLots);
	  }
   }
	
	Profit=Profit*PipValue;
	text2="Profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=OrderstoProtect)
   {	    
	     //Print(Symbol,":",Profit);
	     if ((Profit>=(AccountBalance()*(risk/100) && Money_management)) || (Profit>=(lotsi*(LotSizeValue/100)) && !Money_management))
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("Buy range: ",text3,"\nSellRange: ",text4,"\n","LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text,
	     "\nProperty of Alejandro Gallindo","\nhttp://elcactus.com\nhttp://www.forex-tsd.com");
      }

      if (myOrderType==1 && ContinueOpening) 
      {	
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*Point + (MaxTrades-OpenOrders)*Pips*Point, Digits);  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"Benkyalate by Yast77",Magic,0,Red);		    		    
		    return(0);
	     }
      }
      
      if (myOrderType==2 && ContinueOpening) 
      {
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*Point - (MaxTrades-OpenOrders)*Pips*Point, Digits); }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*Multiplier,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"Benkyalate by Yast77",Magic,0,Blue);		    
		    return(0);
	     }
      }   

//----
   return(0);
  }
//+------------------------------------------------------------------+

int MACD()
{
   myOrderType=3;
   int degree1=0,degree2=0,degree3=0,degree4=0,degree5=0,degree6=0,degree7=0,degree8=0,degree9=0,degree10=0,degree11=0,degree12=0,degree13=0;
   double TopValue1 = iCustom(NULL,COG_Period,"Center of Gravity",bars_back1,m_cog1,i_cog1,kstd1,sName1,1,0);
   double TopValue2 = iCustom(NULL,COG_Period,"Center of Gravity",bars_back2,m_cog2,i_cog2,kstd2,sName2,1,0);
   double BottomValue1 = iCustom(NULL,COG_Period,"Center of Gravity",bars_back3,m_cog3,i_cog3,kstd3,sName3,2,0);
   double BottomValue2 = iCustom(NULL,COG_Period,"Center of Gravity",bars_back4,m_cog4,i_cog4,kstd4,sName4,2,0);
   
   
   double cci1=iCCI( NULL, CCI_Period, CCI_lenght, PRICE_TYPICAL, 0);
   double cci2=iCCI( NULL, CCI_Period, CCI_lenght, PRICE_TYPICAL, 1);
   
   double rsi1=iRSI(NULL,RSI_Period,RSI,PRICE_CLOSE,0);
   double rsi2=iRSI(NULL,RSI_Period,RSI,PRICE_CLOSE,1);
   
   double MacdCurrent=iMACD(NULL,MACD_Period,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   double MacdPrevious=iMACD(NULL,MACD_Period,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   
   double CandleValue = iCustom(NULL,CAN_Period,"CandleAverage_v3",Length,H_period,L_period,C_period,0,0);
   
   if(Ask <= BottomValue2){degree1=3;}
   if(Bid >= TopValue2){degree2=-3;}
   if(Ask <= BottomValue1 && Ask > BottomValue2){degree3=2;}
   if(Bid >= TopValue1 && Bid < TopValue2){degree4=-2;}
   if(CandleValue < -0.81){degree5=2;}
   if(CandleValue > 0.81){degree6=-2;}
   if(CandleValue > -0.81 && CandleValue < 0.81){degree7=0;}
   if(rsi1 > rsi2){degree8=2;}
   if(rsi1 < rsi2){degree9=-2;}
   if(cci1 > cci2){degree10=1;}
   if(cci1 < cci2){degree11=-1;}
   if(MacdCurrent > MacdPrevious){degree12=1;}
   if(MacdCurrent < MacdPrevious){degree13=-1;}
   
   if(degree1==3)
   {
   if(((degree1 + degree5 + degree8 + degree10 + degree12) >= 6)){myOrderType=2;}
   }
   if(degree3==2)
   {
   if(((degree3 + degree5 + degree8 + degree10 + degree12) >= 6)){myOrderType=2;}
   }
   
   if(degree2==-3)
   {
   if(((degree2 + degree6 + degree9 + degree11 + degree13) <= -6)){myOrderType=1;}
   }
   if(degree4==-2)
   {
   if(((degree4 + degree6 + degree9 + degree11 + degree13) <= -6)){myOrderType=1;}
   }
   //if(((degree1 + degree5 + degree8 + degree10 + degree12) >= 6) || ((degree3 + degree5 + degree8 + degree10 + degree12) >= 6)){myOrderType=2;}
   //if(((degree2 + degree6 + degree9 + degree11 + degree13) <= -6) || ((degree4 + degree6 + degree9 + degree11 + degree13) <= -6)){myOrderType=1;}
   
/*
   double MACDMainCurr=iMACD(NULL,0,Fast_EMA,Slow_EMA,Signal_SMA,PRICE_CLOSE,MODE_MAIN,Shift);
   double MACDSigCurr=iMACD(NULL,0,Fast_EMA,Slow_EMA,Signal_SMA,PRICE_CLOSE,MODE_SIGNAL,Shift);
   double MACDMainPre=iMACD(NULL,0,Fast_EMA,Slow_EMA,Signal_SMA,PRICE_CLOSE,MODE_MAIN,Shift+1);
   double MACDSigPre=iMACD(NULL,0,Fast_EMA,Slow_EMA,Signal_SMA,PRICE_CLOSE,MODE_SIGNAL,Shift+1);

   double SellRange=TradingRange*Point;
   double BuyRange=(TradingRange-(TradingRange*2))*Point;

   if(MACDMainCurr>MACDSigCurr && MACDMainPre<MACDSigPre && MACDSigPre<BuyRange && MACDMainCurr<0 && TimeStamp!=iTime(NULL,0,0)) {myOrderType=2; TimeStamp=iTime(NULL,0,0);}
   if(MACDMainCurr<MACDSigCurr && MACDMainPre>MACDSigPre && MACDSigPre>SellRange && MACDMainCurr>0 && TimeStamp!=iTime(NULL,0,0)) {myOrderType=1; TimeStamp=iTime(NULL,0,0);}
   
   text3=DoubleToStr(SellRange,Digits);
   text4=DoubleToStr(BuyRange,Digits);
*/
return(myOrderType);
}

